﻿/***************************************************************/
//惑星
/***************************************************************/
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GreenStar : StartBase
{
    Quaternion vectorRotation;
    Transform vector;
    [HideInInspector]
    public bool Snach = false;
    public GameObject Crash;
    public Vector3 defaultScale = Vector3.zero;

    // Use this for initialization
    void Start()
    {
        vector = transform.FindChild("Vector").transform;
        vectorRotation = transform.localRotation;
        defaultScale = transform.lossyScale;
    }

    // Update is called once per frame
    void Update()
    {
        gameObject.transform.localRotation = Quaternion.Euler(0, 0, gameObject.transform.localRotation.z);

        Move();
        ScaleStay();

        if (!Snach) transform.FindChild("Image").transform.eulerAngles += new Vector3(0, 0, 5.0f);
    }

    void ScaleStay()
    {
        Vector3 lossScale = transform.lossyScale;
        Vector3 localScale = transform.localScale;
        transform.localScale = new Vector3(
            localScale.x / lossScale.x * defaultScale.x,
            localScale.y / lossScale.y * defaultScale.y,
            localScale.z / lossScale.z * defaultScale.z
            );
    }

    //移動
    void Move()
    {
        vector.transform.localRotation = vectorRotation;
        if (Snach == false)
        {
            transform.position += transform.TransformDirection(vector.transform.forward) * speed;
        }
    }

    void OnTriggerEnter(Collider collider)
    {
        if (collider.name == "OutArea") Destroy(this.gameObject);

        //星が衝突したら消える
        if (collider.gameObject.tag == "Star")
        {
            Instantiate(Crash, transform.position, Quaternion.identity);
            Destroy(this.gameObject);
        }
    }
}
