﻿/***************************************************************/
//惑星
/***************************************************************/
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Star : StartBase
{
    Quaternion vectorRotation;
    Transform vector;
    [HideInInspector]
    public bool Snach = false;
    public bool Break = false;
    public GameObject Crash;
    public Vector3 defaultScale = Vector3.zero;

	// Use this for initialization
	void Start () {
        vector = transform.FindChild("Vector").transform;
        vectorRotation = transform.localRotation;
        defaultScale = transform.lossyScale;
    }
	
	// Update is called once per frame
	void Update () {
        //gameObject.transform.localRotation = Quaternion.Euler(0,0, gameObject.transform.localRotation.z);
        transform.eulerAngles = new Vector3(0,0, transform.eulerAngles.z);

        Move();
        ScaleStay();

        if (!Snach) transform.FindChild("Image").transform.eulerAngles += new Vector3(0,0,5.0f);
	}

    void ScaleStay()
    {
        Vector3 lossScale = transform.FindChild("Image").transform.lossyScale;
        Vector3 localScale = transform.FindChild("Image").localScale;
        transform.FindChild("Image").transform.localScale = new Vector3(
            localScale.x / lossScale.x * defaultScale.x,
            localScale.y / lossScale.y * defaultScale.y,
            localScale.z / lossScale.z * defaultScale.z
            );
    }

    //移動
    void Move()
    {
        vector.transform.localRotation = vectorRotation;
        if (Snach == false)
        {
            //greenなら
            if (number == 2) transform.eulerAngles -= new Vector3(0,0,0.1f);
            transform.position += transform.TransformDirection(vector.transform.forward) * speed;
            if(number==3) transform.position += transform.TransformDirection(vector.transform.forward) * speed;
        }
    }

    void OnTriggerEnter(Collider collider)
    {
        if (collider.name == "OutArea" && !Snach) Destroy(this.gameObject);

        //星が衝突したら消える
        if (collider.gameObject.tag == "Star")
        {
            GameObject obj = Instantiate(Crash, transform.position, Quaternion.identity) as GameObject;
            if (Break == false)
            {
                collider.GetComponent<Star>().SeStop();
                obj.GetComponent<StarBreak>().SoundPlay();
                Break = true;
            }
            Destroy(this.gameObject);
        }
    }
    public void SeStop() { Break = true; }
}
