﻿/***************************************************************/
//入力に対してキングを動かす
/***************************************************************/

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class King_Rotate : MonoBehaviour {

    private GameObject KingAxis;
    private GameObject KingWaist;
    private GameObject KingHead;
    [SerializeField]
    private GameObject ChildJellies;
    [SerializeField]
    private ChildJellyMove childJellyMove;
    [SerializeField]
    private Animator anim;
    // [SerializeField]
    public float _Input;
    [SerializeField]
    private float Sensitivity = 1;
    [SerializeField]
    private float ChildDelay = 0.8F;
    [SerializeField]
    private float AnimSpan = 2F;
    [SerializeField]
    private float time = 0;

    public bool isAnim = false;

    private SpriteRenderer HeadSprite;
    private ScoreManager ScoreMng;
    // Use this for initialization
    void Start () {
        KingAxis = gameObject;
        KingWaist = GameObject.Find("King_Waist");
        KingHead = GameObject.Find("King_Head");
        HeadSprite = KingHead.GetComponent<SpriteRenderer>();
        ScoreMng = GameObject.Find("ScoreManager").GetComponent<ScoreManager>();

    }
	
	// Update is called once per frame
	void Update () {
        // if (GameObject.Find("TimeManager").GetComponent<TimeManager>().isCountDown == true) return; 
        _Input = Input.GetAxis("Horizontal") * Sensitivity;

        AxisTurn();             //主軸と頭の回転

        //WaistTurn();            //腰の回転
    }

    void AxisTurn()
    {
        KingAxis.transform.Rotate(0, 0, _Input);
        if (_Input > 0)         //左
        {
            iTween.RotateTo(KingHead, iTween.Hash("z", -90, "islocal", true));
            anim.SetBool("isMove", true);
            anim.SetBool("isIdle", false);
        }
        else if (_Input < 0)    //右
        {
            iTween.RotateTo(KingHead, iTween.Hash("z", 90, "islocal", true));
            anim.SetBool("isMove", true);
            anim.SetBool("isIdle", false);
        }
        else                    //ニュートラル
        {
            iTween.RotateTo(KingHead, iTween.Hash("z", 0, "islocal", true));
            anim.SetBool("isMove", false);
            anim.SetBool("isIdle", true);
        }
    }

    void WaistTurn()
    {
        if (_Input > 0)         //左
        {
            iTween.RotateTo(KingWaist, iTween.Hash("z", -30, "islocal", true));
        }
        else if (_Input < 0)    //右
        {
            iTween.RotateTo(KingWaist, iTween.Hash("z", 30, "islocal", true));
        }
        else                    //ニュートラル
        {
            iTween.RotateTo(KingWaist, iTween.Hash("z", 0, "islocal", true));
        }
    }

    public float GetInput(float input)
    {
        input = _Input;
        return input;
    }
}
