﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;


public class ResultUI : MonoBehaviour
{

    private ScoreManager scoreMng;
    [SerializeField]
    private Text scoreText, rankText, flavorText;
    [SerializeField]
    private Image resultImage;
    [SerializeField]
    private Sprite[] kingSprite = new Sprite[7]; //若いのが上
    [SerializeField]
    public GameObject maskImage, finishImage, resultBack;
    [SerializeField]
    private AudioClip Dram,BGM;
    [SerializeField]
    private AudioClip[] rankSE = new AudioClip[5];
    private AudioClip rankClip;

    private string first, second, third, rank;

    private bool isFinish = false;

    [SerializeField]
    private SaveManager savemanager;

    [SerializeField]
    private AudioClip[] SE;
    private AudioSource[] AUD = new AudioSource[2];

    public GameObject PlsButon;

    // Use this for initialization
    void Start()
    {
        AUD = GetComponents<AudioSource>();
        scoreMng = GameObject.Find("ScoreManager").GetComponent<ScoreManager>();

        Invoke(scoreMng.FinalRank, 0.0f);
        //Debug.Log(scoreMng.FinalRank);
        StartCoroutine("WriteUI");
    }

    void Update()
    {
        if (isFinish && Input.GetKeyDown(KeyCode.Space))
        {
            isFinish = false;
            finishImage.SetActive(true);
            AUD[0].clip = SE[3];
            AUD[0].Play();
            Destroy(GameObject.Find("ScoreManager"));
            Invoke("ToScene", 2.0f);
        }
    }
    void ToScene()
    {
        FadeManager.Instance.LoadScene("Main", 1.0f);
        //SceneManager.LoadScene(0);
    }

    void RankS1()//RGY
    {
        savemanager.SaveCollection(6);
        resultImage.sprite = kingSprite[0];
        rankClip = rankSE[0];
        first = "スペシャルなクラゲ";
        second = "\nバランスの良い食は";
        third = "\n美の基本";
        rank = "S級";
    }
    void RankA2()//GY
    {
        savemanager.SaveCollection(5);
        resultImage.sprite = kingSprite[1];
        rankClip = rankSE[1];
        first = "オシャレでインテリなクラゲ";
        second = "\nノーベル賞も";
        third = "\n目の前だ";
        rank = "A級";
    }
    void RankA3()//RY
    {
        savemanager.SaveCollection(4);
        resultImage.sprite = kingSprite[2];
        rankClip = rankSE[1];
        first = "オシャレ暴力クラゲ";
        second = "\n都会を好み";
        third = "\nグルメをむさぼる";
        rank = "A級";
    }
    void RankB4()//RG
    {
        savemanager.SaveCollection(3);
        resultImage.sprite = kingSprite[3];
        rankClip = rankSE[2];
        first = "普通のクラゲ";
        second = "\n特徴がないことを";
        third = "\n気にしている";
        rank = "B級";
    }
    void RankB5()//Y
    {
        savemanager.SaveCollection(2);
        resultImage.sprite = kingSprite[4];
        rankClip = rankSE[2];
        first = "おしゃれになったクラゲ";
        second = "\nでもおしゃれの味は";
        third = "\nワカラナイ";
        rank = "B級";
    }
    void RankC6()//G
    {
        savemanager.SaveCollection(1);
        resultImage.sprite = kingSprite[5];
        rankClip = rankSE[3];
        first = "地味ギーククラゲ";
        second = "\n栄養ばかり優先して";
        third = "\n頭カッチカッチ";
        rank = "C級";
    }
    void RankD7()//R
    {
        savemanager.SaveCollection(0);
        resultImage.sprite = kingSprite[6];
        rankClip = rankSE[4];
        first = "暴食を繰り返したクラゲ";
        second = "\n今にも爆発しそう";
        third = "\n扱い注意";
        rank = "D級";
    }
    IEnumerator WriteUI()
    {
        int sum = scoreMng.R_COUNT + scoreMng.G_COUNT + scoreMng.Y_COUNT;
        scoreText.text = "スコア:赤い星" + scoreMng.R_COUNT + "個" +
                        "＋緑の星" + scoreMng.G_COUNT + "個" +
                        "+黄の星" + scoreMng.Y_COUNT + "個" +
                        "\n                                                                    = " +
                       sum + "個";
        yield return new WaitForSeconds(2.0f);
        resultBack.SetActive(true);
        //resultImage.sprite = kingSprite[0];
        AUD[0].clip = SE[0];
        AUD[0].Play();
        yield return new WaitForSeconds(1.0f);
        flavorText.text += first;
        AUD[0].clip = SE[1];
        AUD[0].Play();

        AUD[1].clip = Dram;
        AUD[1].Play();
        yield return new WaitForSeconds(1.0f);
        flavorText.text += second;
        AUD[0].Play();
        yield return new WaitForSeconds(1.0f);
        flavorText.text += third;
        AUD[0].Play();
        yield return new WaitForSeconds(1.5f);
        rankText.text = rank;
        AUD[0].clip = SE[2];
        AUD[0].Play();
        yield return new WaitForSeconds(1.0f);
        AUD[1].clip = rankClip;
        AUD[1].Play();
        yield return new WaitForSeconds(2.0f);
        iTween.MoveBy(maskImage, iTween.Hash("y", -200, "easeType", "easeInOutExpo"));
        AUD[0].clip = SE[1];
        AUD[0].Play();
        yield return new WaitForSeconds(1.0f);
        AUD[1].clip = BGM;
        AUD[1].loop = true;
        AUD[1].Play();
        yield return new WaitForSeconds(1.0f);
        isFinish = true;
        PlsButon.SetActive(true);
    }
}
