﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class ScoreManager : MonoBehaviour {
    [SerializeField]
    public Image R_OBJ, G_OBJ, Y_OBJ;
    public GameObject CharaIMG;
    public float RedScore, GreenScore, YellowScore;
    //星のカウント
    [SerializeField]
    public int R_COUNT=0, G_COUNT=0, Y_COUNT=0;

    private float[] list = new float[3];
    public float difference = 0.2f;

    [SerializeField]
    private GameObject _R,_G,_Y,_RG,_RY,_GY,_RGY;

    [SerializeField]
    private GameObject NowCharaIMG;

    [SerializeField]
    private KingChange kingchange;

    public String FinalRank = "RankD7";

    // Use this for initialization
    void Start () {
        if (SceneManager.GetActiveScene().name != "Result")
        {
            DontDestroyOnLoad(gameObject);
        }
    }
	
	// Update is called once per frame
	void Update () {
        if(SceneManager.GetActiveScene().name == "Main")
        {
            SpriteChange();
            if(NowCharaIMG != CharaIMG)
            {
                ChangeChara();
                kingchange.Change();
            }
            ScoreToRank();
        }
    }

    void ScoreToRank()
    {
        if (NowCharaIMG == _R) FinalRank = "RankD7";
        if (NowCharaIMG == _G) FinalRank = "RankC6";
        if (NowCharaIMG == _Y) FinalRank = "RankB5";
        if (NowCharaIMG == _RG) FinalRank = "RankB4";
        if (NowCharaIMG == _RY) FinalRank = "RankA3";
        if (NowCharaIMG == _GY) FinalRank = "RankA2";
        if (NowCharaIMG == _RGY) FinalRank = "RankS1";
    }

    void ChangeChara()
    {
        NowCharaIMG.SetActive(false);
        NowCharaIMG = CharaIMG;
        NowCharaIMG.SetActive(true);

    }

    void SpriteChange()
    {
        R_OBJ.fillAmount = RedScore;
        G_OBJ.fillAmount = GreenScore;
        Y_OBJ.fillAmount = YellowScore;

        list[0] = RedScore;
        list[1] = GreenScore;
        list[2] = YellowScore;

        Array.Sort(list);

        if (list[2] == RedScore)
        {
            if (list[2] - list[1] < difference)
            {
                if (list[1] == GreenScore)
                {
                    if (list[2] - list[0] < difference)
                    {
                        CharaIMG = _RGY;
                        return;
                    }
                    CharaIMG = _RG;
                    return;
                }
                else if (list[1] == YellowScore)
                {
                    if (list[2] - list[0] < difference)
                    {
                        CharaIMG = _RGY;
                        return;
                    }
                        CharaIMG = _RY;
                    return;
                }
            }
            CharaIMG = _R;
            return;
        }
        //-------------------------------------------
        else if (list[2] == GreenScore)
        {
            if (list[2] - list[1] < difference)
            {
                if (list[1] == RedScore)
                {
                    if (list[2] - list[0] < difference)
                    {
                        CharaIMG = _RGY;
                        return;
                    }
                        CharaIMG = _RG;
                    return;
                }
                else if (list[1] == YellowScore)
                {
                    if (list[2] - list[0] < difference)
                    {
                        CharaIMG = _RGY;
                        return;
                    }
                        CharaIMG = _GY;
                    return;
                }
            }
            CharaIMG = _G;
            return;
        }
        //-------------------------------------------
        else if (list[2] == YellowScore)
        {
            if (list[2] - list[1] < difference)
            {
                if (list[1] == RedScore)
                {
                    if (list[2] - list[0] < difference)
                    {
                        CharaIMG = _RGY;
                        return;
                    }
                        CharaIMG = _RY;
                    return;
                }
                else if (list[1] == GreenScore)
                {
                    if (list[2] - list[0] < difference)
                    {
                        CharaIMG = _RGY;
                        return;
                    }
                        CharaIMG = _GY;
                    return;
                }
            }
            CharaIMG = _Y;
            return;
        }
    }

    //ポイントを加算
    public void PointPlus(float red,float green,float yellow)
    {
        RedScore += red;
        GreenScore += green;
        YellowScore+= yellow;

        //Debug.Log("Hit Point Get");

        RedScore = Mathf.Clamp(RedScore,0,1.0f);
        GreenScore = Mathf.Clamp(GreenScore, 0, 1.0f);
        YellowScore = Mathf.Clamp(YellowScore, 0, 1.0f);
    }
    
    //星をカウント
    public void CountStar(int number)
    {
        if (number == 1) { R_COUNT += 1; }
        if (number == 2) { G_COUNT += 1; }
        if (number == 3) { Y_COUNT += 1; }
    }
}
