﻿/***************************************************************/
//子供の生成・移動
/***************************************************************/

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ChildJellyMove : MonoBehaviour {

    GameObject child1;
    GameObject child2;
    GameObject child3;
    GameObject child4;

    StarGet SG,SG1,SG2,SG3,SG4;

    [SerializeField]
    private King_Rotate king_rotate;

    public float moveSpeed = 0.005F;
    public float moveTime = 1.0F;
    public float count = 0;
    public float deathCount = 16;
    public float time = 0;
    public float span = 0.3F;
    public float moveRotate = 0;
    public bool slow = false;
    public GameObject Kirameki;

    float DefSpeed = 0;
    float DashSpeed = 0;

    // Use this for initialization
    void Start () {
        DefSpeed = moveSpeed;
        DashSpeed = moveSpeed * 2;

        king_rotate = GameObject.FindGameObjectWithTag("Player").GetComponent<King_Rotate>();
        slow = false;
        child1 = transform.FindChild("Child1").gameObject;
        SG1 = child1.GetComponent<StarGet>();
        child2 = transform.FindChild("Child2").gameObject;
        SG2 = child2.GetComponent<StarGet>();
        child3 = transform.FindChild("Child3").gameObject;
        SG3 = child3.GetComponent<StarGet>();
        child4 = transform.FindChild("Child4").gameObject;
        SG4 = child4.GetComponent<StarGet>();
    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetKey(KeyCode.Space)) moveSpeed = DashSpeed;
        else moveSpeed = DefSpeed;

        if (slow)
        {
            moveRotate = -king_rotate._Input * 0.3F;
        }
        // MoveChild();
        time += Time.deltaTime;
        if (time >= span)
        {
            time = 0;
            count++;
            if (count >= deathCount)
            {
                Destroy(gameObject);
            }
            ChangeType();
        }
        //回転
        if (child1 != null)
        {
            if (SG1.Get == false)
                child1.transform.Rotate(0, 0, moveRotate);
            else if (SG1.Get == true)
                Die(child1);
        }
        if (child2 != null)
        {
            if (SG2.Get == false)
                child2.transform.Rotate(0, 0, moveRotate);
            else if (SG2.Get == true)
                Die(child2);
        }
        if (child3 != null) {
        if (SG3.Get == false)
            child3.transform.Rotate(0, 0, moveRotate);
        else if (SG3.Get == true)
            Die(child3); }
        if (child4 != null)
        {
            if (SG4.Get == false)
                child4.transform.Rotate(0, 0, moveRotate);
            else if (SG4.Get == true)
                Die(child4);
        }
    }

    void Die(GameObject C)
    {
        float dis = Vector3.Distance(C.transform.position, Vector3.zero);
        if(dis < 1.0f)
        {
            Vector3 Ppos = new Vector3(0.0f,0.0f,0.0f);
            //ポイント加算処理
            if (C.transform.FindChild("Star(Clone)") != null)
            {
                Ppos = C.transform.FindChild("Star(Clone)").position;
                C.transform.FindChild("Star(Clone)").GetComponent<StartBase>().Dead();
            }
            if (C.transform.FindChild("GreenStar(Clone)") != null)
            {
                Ppos = C.transform.FindChild("GreenStar(Clone)").position;
                C.transform.FindChild("GreenStar(Clone)").GetComponent<StartBase>().Dead();
            }
            if (C.transform.FindChild("YellowStar(Clone)") != null)
            {
                Ppos = C.transform.FindChild("YellowStar(Clone)").position;
                C.transform.FindChild("YellowStar(Clone)").GetComponent<StartBase>().Dead();
            }

            Instantiate(Kirameki, Ppos, Quaternion.identity);
            Destroy(C);
        }
    }


    public void MoveAnimation()
    {
        if (child1 != null)
        {

            // child1のうにょーん
            iTween.MoveBy(child1, iTween.Hash(
            "x", -moveSpeed * (count / 2),
            "time", moveTime,
            "easeType", "easeOutQuad"
        ));
            iTween.MoveBy(child1, iTween.Hash(
                "y", moveSpeed * (count / 2),
                "time", moveTime,
                "easeType", "easeOutQuad"
            ));
        }
        if (child2 != null)
        {
            // child2のうにょーん
            iTween.MoveBy(child2, iTween.Hash(
            "x", moveSpeed * (count / 2),
            "time", moveTime,
            "easeType", "easeOutQuad"
        ));
            iTween.MoveBy(child2, iTween.Hash(
                "y", moveSpeed * (count / 2),
                "time", moveTime,
                "easeType", "easeOutQuad"
            ));
        }
        if (child3 != null)
        {
            // child3のうにょーん
            iTween.MoveBy(child3, iTween.Hash(
            "x", -moveSpeed * (count / 2),
            "time", moveTime,
            "easeType", "easeOutQuad"
        ));
            iTween.MoveBy(child3, iTween.Hash(
                "y", moveSpeed * (count / 2),
                "time", moveTime,
                "easeType", "easeOutQuad"
            ));
        }
        if (child4 != null)
        {
            // child4のうにょーん
            iTween.MoveBy(child4, iTween.Hash(
            "x", moveSpeed * (count / 2),
            "time", moveTime,
            "easeType", "easeOutQuad"
        ));
            iTween.MoveBy(child4, iTween.Hash(
                "y", moveSpeed * (count / 2),
                "time", moveTime,
                "easeType", "easeOutQuad"
            ));
        }
    }

    public void ChangeType()
    {
        if (!slow)
        {
            slow = true;
            MoveAnimation();
        } else
        {
            slow = false;
        }
    }

    public void MoveChild()
    {
        if (!slow)
        {
            if (child1 != null) child1.transform.position += new Vector3(-moveSpeed, moveSpeed, 0);
            if (child2 != null) child2.transform.position += new Vector3(moveSpeed, moveSpeed, 0);
            if (child3 != null) child3.transform.position += new Vector3(moveSpeed, -moveSpeed, 0);
            if (child4 != null) child4.transform.position += new Vector3(-moveSpeed, -moveSpeed, 0);
        } 
    }
}
