﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;


public class ResultUI : MonoBehaviour
{

    private ScoreManager scoreMng;
    [SerializeField]
    private Text scoreText, rankText, flavorText;
    [SerializeField]
    private Image resultImage;
    [SerializeField]
    private Sprite[] kingSprite = new Sprite[7]; //若いのが上
    [SerializeField]
    public GameObject maskImage, finishImage, resultBack;

    private string first, second, third, rank;

    private bool isFinish = false;

    [SerializeField]
    private AudioClip[] SE;
    private AudioSource AUD;
    // Use this for initialization
    void Start()
    {
        AUD = GetComponent<AudioSource>();
        scoreMng = GameObject.Find("ScoreManager").GetComponent<ScoreManager>();

        Invoke(scoreMng.FinalRank, 0.0f);
        //Debug.Log(scoreMng.FinalRank);
        StartCoroutine("WriteUI");
    }

    void Update()
    {
        if (isFinish && Input.GetKeyDown(KeyCode.Space))
        {
            finishImage.SetActive(true);
            AUD.clip = SE[3];
            AUD.Play();
            Invoke("ToScene", 2.0f);
        }
    }
    void ToScene()
    {
        FadeManager.Instance.LoadScene("Main", 1.0f);
        //SceneManager.LoadScene(0);
    }

    void RankS1()//RGY
    {
        resultImage.sprite = kingSprite[0];
        first = "スペシャルなクラゲ";
        second = "\nバランスの良い食は";
        third = "\n美の基本";
        rank = "S級";
    }
    void RankA2()//GY
    {
        resultImage.sprite = kingSprite[1];
        first = "クールビューティなクラゲ";
        second = "\nその美しさは";
        third = "\n宝石のよう";
        rank = "A+級";
    }
    void RankA3()//RY
    {
        resultImage.sprite = kingSprite[2];
        first = "方向性を間違えたクラゲ";
        second = "\nあのころはそう";
        third = "\n若かった";
        rank = "A級";
    }
    void RankB4()//RG
    {
        resultImage.sprite = kingSprite[3];
        first = "標準的なクラゲ";
        second = "\nおしゃれになりたい";
        third = "\nおとしごろ";
        rank = "B+級";
    }
    void RankB5()//Y
    {
        resultImage.sprite = kingSprite[4];
        first = "おしゃれになったクラゲ";
        second = "\nでもおしゃれの味は";
        third = "\nワカラナイ";
        rank = "B級";
    }
    void RankC6()//G
    {
        resultImage.sprite = kingSprite[5];
        first = "健康になり過ぎたクラゲ";
        second = "\n気を使い過ぎても";
        third = "\n困りもの";
        rank = "C級";
    }
    void RankD7()//R
    {
        resultImage.sprite = kingSprite[6];
        first = "暴食を繰り返したクラゲ";
        second = "\n今にも爆発しそう";
        third = "\n扱い注意";
        rank = "D級";
    }
    IEnumerator WriteUI()
    {
        int sum = scoreMng.R_COUNT + scoreMng.G_COUNT + scoreMng.Y_COUNT;
        scoreText.text = "スコア:赤い星" + scoreMng.R_COUNT + "個" +
                        "＋緑の星" + scoreMng.G_COUNT + "個" +
                        "+黄の星" + scoreMng.Y_COUNT + "個" +
                        "\n                                                                    = " +
                       sum + "個";
        yield return new WaitForSeconds(2.0f);
        resultBack.SetActive(true);
        //resultImage.sprite = kingSprite[0];
        AUD.clip = SE[0];
        AUD.Play();
        yield return new WaitForSeconds(1.0f);
        flavorText.text += first;
        AUD.clip = SE[1];
        AUD.Play();
        yield return new WaitForSeconds(1.0f);
        flavorText.text += second;
        AUD.Play();
        yield return new WaitForSeconds(1.0f);
        flavorText.text += third;
        AUD.Play();
        yield return new WaitForSeconds(1.5f);
        rankText.text = rank;
        AUD.clip = SE[2];
        AUD.Play();
        yield return new WaitForSeconds(1.0f);
        iTween.MoveBy(maskImage, iTween.Hash("y", -200, "easeType", "easeInOutExpo"));
        AUD.clip = SE[1];
        AUD.Play();
        yield return new WaitForSeconds(2.0f);
        isFinish = true;
    }
}
